/*
 * ASE1502.asm
 *
 * Created: 14/09/2015 18.23.47
 * Author: Roberto Roncella
 * Compito di allenamento, mai sottoposto in un vero appello
 * Realizzare una subroutine per un microcontrollore della famiglia AVR 
 * che valuta il determinante di una matrice 3x3 contenuta in memoria, per righe, 
 * a partire dall'indirizzo contenuto in Z. 
 * Gli elementi della matrice sono singole cifre esadecimali e il risultato in complemento a 2
 * deve essere lasciato nella coppia di registri R1:R0. 
 * Esistono casi in cui il risultato non  rappresentabile?
 *
 * Il risultato e' sempre rappresentabile, in quanto minore in modulo di 2*15^3=6750
 * Tale valore si ottiene per esempio con 15,15,0,0,15,15,15,0,15
 */ 

test: //sezione di test della subroutine
 ldi ZL,low(a11) //vedi la sezione dseg
 ldi ZH,high(a11)
 here:
 rcall det3x3 //predisporre la memoria con il debugger
 rjmp here

det3x3:
 push R2 //salva i registri usati
 push R3
 push R16
 push R17
 push R18
 ldd R16,Z+0 //a11
 ldd R17,Z+4 //a22
 ldd R18,Z+8 //a33
 mul R16,R17
 mul R0,R18
 movw R3:R2,R1:R0
 ldd R16,Z+1 //a12
 ldd R17,Z+5 //a23
 ldd R18,Z+6 //a31
 mul R16,R17
 mul R0,R18
 add R2,R0
 adc R3,R1
 ldd R16,Z+2 //a13
 ldd R17,Z+3 //a21
 ldd R18,Z+7 //a32
 mul R16,R17
 mul R0,R18
 add R2,R0
 adc R3,R1
 ldd R16,Z+2 //a13
 ldd R17,Z+4 //a22
 ldd R18,Z+6 //a31
 mul R16,R17
 mul R0,R18
 sub R2,R0
 sbc R3,R1
 ldd R16,Z+0 //a11
 ldd R17,Z+5 //a23
 ldd R18,Z+7 //a32
 mul R16,R17
 mul R0,R18
 sub R2,R0
 sbc R3,R1
 ldd R16,Z+1 //a12
 ldd R17,Z+3 //a21
 ldd R18,Z+8 //a33
 mul R16,R17
 mul R0,R18
 sub R2,R0
 sbc R3,R1
 movw R1:R0,R3:R2
 pop R18 //rispristina i registri
 pop R17
 pop R16
 pop R3
 pop R2
 ret

.dseg
.org 0x2500
a11: .byte 1
a12: .byte 1
a13: .byte 1
a21: .byte 1
a22: .byte 1
a23: .byte 1
a31: .byte 1
a32: .byte 1
a33: .byte 1